//PIC24FJ64GA002 8MHz internal clock (PLL=32MHz)
//HtSC1602 eXgvO
//2007.9.11  
//
//FMPLAB IDE v7.62
//RpCFC30 v3.01 (19 June 2007)
//C^[FPICkit2 v2.40
//
//RpCœK:
//
//Fubh{[h
//            HtSC1602
//PORTB 15 -  DB7
//PORTB 14 -  DB6
//PORTB 13 -  DB5
//PORTB 12 -  DB4
//PORTB 11 -  E
//PORTB 10 -  RS
//
//PORTB 6  - LED
//

#include "p24FJ64GA002.h"
#include "lcd.h"

#define F_CPU           32000000UL  //CNbNg 32MHz

extern int delay_cycle(unsigned int n);
extern int delay_msec(unsigned int n, unsigned int m);

//CONFIG͂ohbetm̂̂Qlɂ܂(FRC PLLLɂĂ܂)
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 & FWDTEN_OFF )
_CONFIG2(IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)

void delay_ms(unsigned int ms)
{
    #define one_loop_cycle 1UL //one loop = 1 cycle
    #define clock_per_cycle 2UL // clock / cycle@ (PTCNQNbNĂHH)
    #define delay_1msec_wk ((F_CPU/1000UL) / (one_loop_cycle*clock_per_cycle))
    #define delay_1msec_val (delay_1msec_wk-5UL) //-5UL͎ԕ␳l

    delay_msec(delay_1msec_val, ms);
}

int main()
{
    _RCDIV = 0;//PostScaler   ( 0 : 32MHz   1 : 16MHz )

    TRISB = 0b10111111;//PORTB bit6 OUTPUT

   while(1){
        LATB &= ~0b01000000;//LED_

        lcd_init();//|[g̏̒łȂĂ܂
        lcd_cls();

        lcd_gotopos(0,0);//x=0, line=0
        lcd_putstr("WELCOME PIC24F");

        lcd_gotopos(0,1);//x=0, line=1
        lcd_putstr("PIC24FJ64GA002");

        LATB |= 0b01000000;//LED
 
        delay_ms(2000);
    }
 
    return 1;
}
